#!/usr/bin/env python
# Copyright (c) 2011 Praveen Kumar <kumarpraveen.nitdgp@gmail.com>
#
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation
# files (the "Software"), to deal in the Software without
# restriction, including without limitation the rights to use,
# copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following
# conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.

import os
import sys
import time
from config import Config
from stat import *


# This function return the modified file list
def enumratefiles(path):
    d = {}
    with open(os.path.expanduser("~")+'/.lsync/file_info.cfg') as f:
        for line in f:
           (key, val) = line.split("|")
           d[key] = val
    files_list=[]
    directory_name = path
    for dirpath,dirnames,filenames in os.walk(directory_name):
        for name in filenames:
            file_path = os.path.join(dirpath,name)
            file_size = os.path.getsize(os.path.join(dirpath, name))
            if d.get(name):
                if d[name] != time.ctime(os.path.getctime(file_path))+"\n":
                    files_list.append([name,file_path,file_size])
            else:
                files_list.append([name,file_path,file_size])
    return files_list

#function which returned deleted file list
def deleted_files(path):
    d = {}
    with open(os.path.expanduser("~")+'/.lsync/file_info.cfg') as f:
        for line in f:
           (key, val) = line.split("|")
           d[key] = val
    files_list_back=[]
    directory_name = path
    for dirpath,dirnames,filenames in os.walk(directory_name):
        for name in filenames:
            files_list_back.append(name)
    key_list = d.keys()
    delete_files = list(set(key_list)-set(files_list_back))
    return delete_files

#List all the files in perticular location
def lists_files(path):
    #given a absoulte path 
    file_path = os.path.expanduser("~")+'/.lsync/file_info.cfg'
    #making a file object and handle any exception errors
    try:
        file_object = file(file_path,'w') #create a file object in write mode
    except IOError, error:
        print "problem with reading %s and getting error: %s" % (path, error)

    files_list=[]
    directory_name = path
    for dirpath,dirnames,filenames in os.walk(directory_name):
        for name in filenames:
            file_path = os.path.join(dirpath,name)
            mod_time = time.ctime(os.path.getctime(file_path))
            file_object.write(name+"|" + mod_time + "\n")

#Reading from configuration file
def conf_read():
    config = []
    f = file(os.path.expanduser("~")+'/.lsync/lsync.cfg')
    cfg = Config(f)
    config.append(cfg.Host)
    config.append(cfg.Port)
    config.append(cfg.Username)
    config.append(cfg.Password)
    config.append(cfg.Path)
    return config
    
# Send Files in chunks

def data_transfer(s,filepath,filesize):
    try:
        f = open(filepath,"r")
    except IOError,message:
        print >> sys.stderr , "Error in file opening", message
        return 0
    data_read = 0
    chunk_size = 4096
    while data_read < int(filesize):
        s.send(f.read(chunk_size))
        data_read+=chunk_size
        #print "bytes sends %d",data_read
    return 1
