#!/usr/bin/env python
# Copyright (c) 2011 Praveen Kumar <kumarpraveen.nitdgp@gmail.com>
#
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation
# files (the "Software"), to deal in the Software without
# restriction, including without limitation the rights to use,
# copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following
# conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.

#create a general server 
import socket
import sys
import traceback
import os
import time
from config import Config
from server_function import *

#creating a socket
try:
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
except socket.error,e:
    print "Strange error creating socket %s " %e
    sys.exit(1)
    
#set the socket's option
try:
	#s.setsockopt() is takes socket option and level which is define in SQL_SOCKET and value, its return a int value if successful then 0 otherwise -1
    s.setsockopt(socket.SOL_SOCKET,socket.SO_REUSEADDR,1)
except socket.error,e:
    print "Error in socket option %s " %e
    sys.exit(1)

#bind all interface
host="" 
port=int(sys.argv[1])

#binding the server with specific port
try:
    s.bind((host,port))
except socket.error,e:
    print "error in Binding %s " %e
    sys.exit(1)
    
#Listing to a port
try:
    s.listen(1)
    print "listening ...."
except socket.error,e:
    print "error in listening %s " %e
    sys.exit(1)

#Accept request from a client
while 1:
    try:
		#s.accept() is return a new socket object and 
        #address bound to the socket on the other end of the connection.       
        clientsock,clientAddr = s.accept()
    except KeyboardInterrupt:
        raise
    except:
        traceback.print_exc()
        continue
    
    #Creating user directory and give a valid path
    try:
        print "Got connection from",clientsock.getpeername()
        data = clientsock.recv(1024)
        if data:
            print data
            username,password = data.split('\t')
            user_pass = user_detail(username)
            if user_pass != "^&*":
                if password == user_pass:    
                    clientsock.send("ok")
                    path = "/var/www/html/"+username+"/"
                    try:
                        #start Processing from Here
                        while 1:
                            data = clientsock.recv(1024)
                            #print "received detail"
                            if data:
                                print data
                                filename,filesize = data.split(":")
                                if filesize is "D":
                                    deleted_files(path,filename)
                                else:
                                    clientsock.send("ok")
                                    check = data_transfer(path,filename,filesize,clientsock)
                                    if not check:
                                        print "error in backup"
                                        sys.exit(1)
                            else:
                                break;
                            print "next iteration"
                            
                        #Process the request here
                    except(KeyboardInterrupt,SystemExit):
                        raise
                    except:
                        traceback.print_exc()
                    try:
                        clientsock.close()
                    except(KeyboardInterrupt):
                        raise
                    except:
                        traceback.print_exc()

                else:
                    clientsock.send("fail")
            else:
                user_add(username,password)
                clientsock.send("add")
        else:
            sys.exit(1)
    except(KeyboardInterrupt,SystemExit):
        raise
    except:
        traceback.print_exc()
    
    