/*Copyright (c) 2011 Praveen Kumar <kumarpraveen.nitdgp@gmail.com>

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.*/

#include "lsync.h"
#include "ui_lsync.h"
#include <QDir>

Lsync::Lsync(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Lsync)
{
    ui->setupUi(this);
    connect(ui->Accept,SIGNAL(clicked()),this,SLOT(accept()));
    connect(ui->Open,SIGNAL(clicked()),this,SLOT(open()));
    connect(ui->clear,SIGNAL(clicked()),this,SLOT(clear()));
    connect(this,SIGNAL(done()),this,SLOT(close()));
}

Lsync::~Lsync()
{
    delete ui;
}
void Lsync::accept()
{
    if(!(ui->hostLineEdit->text().isEmpty() || ui->portLinedit->text().isEmpty()
         || ui->usernameLineEdit->text().isEmpty() || ui->passwordLineEdit->text().isEmpty()
         || ui->pathLineEdit->text().isEmpty()))
    {
        host =ui->hostLabel->text()+" : " + "'" + ui->hostLineEdit->text()+"'"+"\n";
        port =ui->portLabel->text()+" : " + "'" + ui->portLinedit->text()+"'" +"\n";
        username =ui->usernameLabel->text()+" : " +"'" + ui->usernameLineEdit->text()+"'" +"\n";
        password =ui->passwordLabel->text()+" : " +"'" + ui->passwordLineEdit->text()+"'" +"\n";
        path =ui->pathLabel->text()+":" + "'" + ui->pathLineEdit->text()+"'" ;
        QString configration = host+port+username+password+path;
        QByteArray host1= configration.toAscii();
        QDir dir;
        bool success = dir.mkdir(dir.homePath()+"/.lsync");
        if(!success)
        {
            qDebug("Error with creating dir");
        }
        QFile f(dir.homePath()+"/.lsync/lsync.cfg");
        if(!f.open(QIODevice::WriteOnly))
        {
            qDebug() << "problem with opening";
        }
        f.write(host1);
        f.close();
        QFile f1(dir.homePath()+"/.lsync/file_info.cfg");
        if(!f1.open(QIODevice::WriteOnly))
        {
            qDebug() << "problem with opening";
        }
        f1.close();
        emit done();

    }
    else
        QMessageBox::warning(this,"Warning","Fill All Fields",QMessageBox::Ok);

}
void Lsync::open()
{
    dir = QFileDialog::getExistingDirectory(this,QObject::tr("Open Directory"),"~/Videos");
    ui->pathLineEdit->setText(dir);
}
void Lsync::clear()
{
    ui->hostLineEdit->clear();
    ui->portLinedit->clear();
    ui->usernameLineEdit->clear();
    ui->passwordLineEdit->clear();
    ui->pathLineEdit->clear();
}
